{$FORM TMainForm, Unit2.sfm}                                                                                                                                               
                                                      
uses
  Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, DateUtils, 
  ExtCtrls, UniDB, DB, ADODB, Registry, FuncScript, SysUtils, 
  Grids, DBGrids, DBTables, DBClient;    


var 
  dtMonth, dtWeek, dtToday, dtNow : TDateTime;  
  cds : TClientDataset; 
  dbMonitor : string;

procedure SetConnection;
begin                                                                                                                                       
  dbMonitor := ExecuteFuncScript('ExecuteScript("ProcDocs\open_monitor_db.prd")');
  qMed.DatabaseName := dbMonitor;
  qBackups.DatabaseName := dbMonitor;    
end;                       
       
procedure btnCloseClick(Sender: TObject);
begin
  Close;
end;

//      
function FDOM(Date: TDateTime): TDateTime;
var 
  Year, Month, Day : Word;
begin
  DecodeDate(Date, Year, Month, Day);
  Result := EncodeDate(Year, Month, 1);
end;                                                         
                             
//   
function FDOW(Date: TDateTime): TDateTime;
begin                                     
  Result := Date - DayOfTheWeek(Date) + 1;                           
end;                                                               

function GetMedCount(date : TDateTime): Integer;
begin                                           
  if not qMed.Active then qMed.Active := True;  
  qMed.Active := false;
//  qMed.Params.ParamByName('dtFrom').Value := FormatDateTime('yyyy-mm-dd', date);        
  qMed.Params.ParamByName('dtFrom').Value := FormatDateTime('dd.mm.yyyy', date);        
  qMed.Active := true;   
  Result := qMed.FieldByName('C').Value;
end;    
                          
function GetJourCount(date : TDateTime): Integer;
begin
  if not qJour.Active then qJour.Active := True;
  qJour.Params.ParamByName('dtFrom').Value := date;  
  qJour.Reopen;   
  Result := qJour.FieldByName('C').Value;                  
end;
                                                        
procedure UpdateTable;
begin
  cds.EmptyDataSet;    
                    
  cds.Append;                                                   
  cds.FieldByName('descr').AsString := '  ';
  cds.FieldByName('med').AsInteger := GetMedCount(dtMonth);
  cds.FieldByName('jour').AsInteger := GetJourCount(dtMonth);            
  cds.Append;                                        
  cds.FieldByName('descr').AsString := '  ';
  cds.FieldByName('med').AsInteger := GetMedCount(dtWeek);             
  cds.FieldByName('jour').AsInteger := GetJourCount(dtWeek);    
  cds.Append;       
  cds.FieldByName('descr').AsString := ' ';
  cds.FieldByName('med').AsInteger := GetMedCount(dtToday);             
  cds.FieldByName('jour').AsInteger := GetJourCount(dtToday);
  cds.Post;                                                                                      
end;                                  
                                                     
procedure MainForm_1Create(Sender: TObject);   
var                                                                                
  sSQLKey : String;
begin                
  Width := 600;
  Height := 300;
  
  dtMonth := FDOM(Date);
  dtWeek := FDOW(Date);
  dtToday := Date;         
  dtNow := Now;        
  
  Case ExecuteFuncScript('GetDatabaseType("dbJournals");') of
    'MSSQL': begin  
      qJour.SQL.Clear;
      qJour.SQL.Add('SELECT COUNT(*) AS C');
      qJour.SQL.Add('FROM JRGOODOUT2');      
      qJour.SQL.Add('WHERE');      
      qJour.SQL.Add('SENDDATE + ' +chr(39)+ ' ' +chr(39)+ ' + SENDTIME >= :dtFrom');      
      qJour.Params.ParamByName('dtFrom').DataType := 11;
      qJour.Active := true;
    end;
    'PARADOX': begin
    end;
  end;
                                     
  SetConnection();  
  qMed.Active := True;                 
                           
  cds := TClientDataSet.Create(self);                      
  cds.FieldDefs.Add('descr', ftString, 30, True);
  cds.FieldDefs.Add('med', ftInteger, 0, True);               
  cds.FieldDefs.Add('jour', ftInteger, 0, True);
  
  cds.CreateDataSet;  
  
  dsMain.DataSet := cds;
  gdMain.DataSource := dsMain;                                   
  
  gdMain.Columns.Items[0].Title.Font.Style := [fsBold];       
  gdMain.Columns.Items[0].Title.Caption := '';   
  gdMain.Columns.Items[0].Title.Alignment := 2;
  gdMain.Columns.Items[0].Width := 220;
  gdMain.Columns.Items[1].Title.Font.Style := [fsBold];       
  gdMain.Columns.Items[1].Title.Caption := '   ';  
  gdMain.Columns.Items[1].Title.Alignment := 2;  
  gdMain.Columns.Items[1].Alignment := 2;      
  gdMain.Columns.Items[1].Width := 170;  
  gdMain.Columns.Items[2].Title.Font.Style := [fsBold];         
  gdMain.Columns.Items[2].Title.Caption := '  ';  
  gdMain.Columns.Items[2].Title.Alignment := 2;
  gdMain.Columns.Items[2].Alignment := 2; 
  gdMain.Columns.Items[2].Width := 170;  
             
  UpdateTable; 
  
  btnReloadWhgou.Enabled := dsMain.DataSet.FieldByName('med').Value > dsMain.DataSet.FieldByName('jour').Value;
end;                             

procedure SaveXmlDocument(sFile: String);
var         
  sDir : String;  
begin
  sDir := ExtractFilePath(Application.ExeName) + 'STS-MED\iout\';
  if Length (ExecuteFuncScript ('UserInfo("", "UserUUID")')) > 0 then
    sDir := sDir + ExecuteFuncScript ('UserInfo("", "UserUUID")') + '\';

  ExecuteFuncScript (
    'VAR("XmlDoc", Integer);' +
    'VAR ("XmlObject", Integer);' +
    'VAR ("XmlBody", Integer);' +
    'XmlDoc := XMLDOCUMENTCREATE();' +
    'XMLDOCUMENTLOAD (XmlDoc, "' + sFile + '");' +
    'XmlObject := XMLNODEFIND (XMLNODEFIND (XMLNODEFIND (XMLNODECHILD (XMLDOCUMENTROOT (XmlDoc), 0), "Body"), "Signature"), "Object");' +             
    'IF (XMLNODEFIND (XmlObject, "ED_Container"), XmlObject := XMLNODEFIND (XMLNODEFIND (XMLNODEFIND (XMLNODEFIND (XMLNODEFIND (XmlObject, "ED_Container"), "ContainerDoc"), "DocBody"), "Signature"), "Object"));' +
    'XmlBody := XMLNODECHILD (XmlObject, 0);XMLNODESAVE (XmlBody, "' + sDir + ExtractFileName(sFile) + '");'   
  ); // ExecuteFuncScripts

end;                                                          

procedure ReloadWHGou;                  
var 
  iMissedFiles, iIncoming : Integer;
  sMsg, sScript, sBackupFile : String;   
begin         
  iMissedFiles := 0;
  qBackups.First;            
  while not qBackups.Eof do
    begin                                                           
      if qBackups.FieldByName('INCOMING').Value then
        iIncoming := 1
      else
        iIncoming := 0;   
        
      sScript := 'EXECUTESCRIPT (INCLUDETRAILINGBACKSLASH (PROGRAMPATH ()) + "ProcDocs\utils\get_backup_file.prd");' +
                 'GetBackupFile ("' + VarToStr(qBackups.FieldByName('BACKUPFILE').Value) + '", ' +  VarToStr(iIncoming) + ')';           
      sBackupFile := ExecuteFuncScript(sScript);     
      if FileExists(sBackupFile) then      
        SaveXmlDocument(sBackupFile);  
      else 
        iMissedFiles := iMissedFiles + 1;
        
      qBackups.Next; 
    end;
  ExecuteFuncScript('VAR ("iShowProgressBar", Integer, 1);' +  
                    'EXECUTESCRIPT (INCLUDETRAILINGBACKSLASH (PROGRAMPATH ()) + "Data\Impex\Scripts\eps.imp");');

  if iMissedFiles > 0 then 
    begin
      sMsg := ' .'; 
      sMsg := sMsg + chr(13) + '     ' + IntToStr(iMissedFiles) + ' (-).';
      MessageDlg(sMsg, mtInformation, mbOK, 0);  
    end;
end;                                                           
                               
procedure gdMainCellClick(Column: TColumn);                     
begin
  btnReloadWhgou.Enabled := dsMain.DataSet.FieldByName('med').Value > dsMain.DataSet.FieldByName('jour').Value;
end;

procedure btnReloadWhgouClick(Sender: TObject);
begin
  qBackups.Active := False; 
  qBackups.Params.ParamByName('dtFrom').DataType := 9; 
  Case dsMain.DataSet.FieldByName('descr').Value of
    '  ':  begin   
      qBackups.Params.ParamByName('dtFrom').Value := FormatDateTime('yyyy-mm-dd', dtMonth); 
    end;                                                
    '  ':  begin   
      qBackups.Params.ParamByName('dtFrom').Value := FormatDateTime('yyyy-mm-dd', dtWeek);    
    end;
    ' ': begin  
      qBackups.Params.ParamByName('dtFrom').Value := FormatDateTime('yyyy-mm-dd', dtToday);    
    end;                                                   
  end;    
  qBackups.Active := True;    
                                        
  ReloadWHGou;                            
  UpdateTable;  
end;

begin                                                        
end;                                            
